import 'package:doctor_app_flutter/core/viewModel/project_view_model.dart';
import 'package:doctor_app_flutter/models/patient/vital_sign/patient-vital-sign-data.dart';
import 'package:doctor_app_flutter/models/patient/vital_sign/patient-vital-sign-history.dart';
import 'package:doctor_app_flutter/util/date-utils.dart';
import 'package:doctor_app_flutter/util/translations_delegate_base.dart';
import 'package:doctor_app_flutter/widgets/shared/app_texts_widget.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

class VitalSignBloodPressureWidget extends StatefulWidget {
  final List<VitalSignHistory> vitalList;
  final String title1;
  final String title2;
  final String title3;
  final String viewKey1;
  final String viewKey2;

  VitalSignBloodPressureWidget(
      {Key key, this.vitalList, this.title1, this.title2, this.viewKey1, this.title3, this.viewKey2});

  @override
  _VitalSignDetailsWidgetState createState() => _VitalSignDetailsWidgetState();
}

class _VitalSignDetailsWidgetState extends State<VitalSignBloodPressureWidget> {
  @override
  Widget build(BuildContext context) {
    ProjectViewModel projectViewModel = Provider.of(context);
    return Container(
      decoration: BoxDecoration(
        color: Colors.transparent,
        borderRadius: BorderRadius.only(
            topLeft: Radius.circular(10.0), topRight: Radius.circular(10.0)),
        border: Border.all(color: Colors.grey, width: 1),
      ),
      margin: EdgeInsets.all(20),
      child: Container(
        color: Colors.transparent,
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: <Widget>[
            Table(
              border: TableBorder.symmetric(
                inside: BorderSide(width: 2.0, color: Colors.grey[300]),
              ),
              children: fullData(projectViewModel),
            ),
          ],
        ),
      ),
    );
  }

  List<TableRow> fullData(ProjectViewModel projectViewModel) {
    List<TableRow> tableRow = [];
    tableRow.add(TableRow(children: [
      Container(
        child: Container(
          decoration: BoxDecoration(
            color: Theme.of(context).primaryColor,
            borderRadius: BorderRadius.only(
              topLeft:projectViewModel.isArabic? Radius.circular(0.0):Radius.circular(10.0),
              topRight: projectViewModel.isArabic? Radius.circular(10.0):Radius.circular(0.0)
            ),
          ),
          child: Center(
            child: AppText(
              TranslationBase.of(context).date,
              color: Colors.white,
            ),
          ),
          height: 60,
        ),
      ),
      Container(
        child: Container(
            decoration: BoxDecoration(
              color: Theme.of(context).primaryColor,

            ),
            child: Center(
              child: AppText(widget.title2, color: Colors.white),
            ),
            height: 60),
      ),
      Container(
        child: Container(
            decoration: BoxDecoration(
              color: Theme.of(context).primaryColor,
              borderRadius: BorderRadius.only(
                topRight: projectViewModel.isArabic? Radius.circular(0.0):Radius.circular(10.0),
                topLeft: projectViewModel.isArabic? Radius.circular(10.0):Radius.circular(0.0)
              ),
            ),
            child: Center(
              child: AppText(widget.title3, color: Colors.white),
            ),
            height: 60),
      ),
    ]));
    widget.vitalList.forEach((vital) {
      var data = vital.toJson()[widget.viewKey1];
      DateTime elementDate =
      DateUtils.getDateTimeFromServerFormat(vital.createdOn);
      if (data != 0)
        tableRow.add(TableRow(children: [
          Container(
            child: Container(
              padding: EdgeInsets.all(10),
              color: Colors.white,
              child: Center(
                child: AppText(
                  '${projectViewModel.isArabic ? DateUtils.getWeekDayArabic(elementDate.weekday) : DateUtils.getWeekDay(elementDate.weekday)}, ${elementDate.day} ${projectViewModel.isArabic ? DateUtils.getMonthArabic(elementDate.month) : DateUtils.getMonth(elementDate.month)}, ${elementDate.year} ',
                  textAlign: TextAlign.center,
                ),
              ),
            ),
          ),
          Container(
            child: Container(
              padding: EdgeInsets.all(10),
              color: Colors.white,
              child: Center(
                child: AppText(
                  '${vital.toJson()[widget.viewKey1]}',
                  textAlign: TextAlign.center,
                ),
              ),
            ),
          ),
          Container(
            child: Container(
              padding: EdgeInsets.all(10),
              color: Colors.white,
              child: Center(
                child: AppText(
                  '${vital.toJson()[widget.viewKey2]}',
                  textAlign: TextAlign.center,
                ),
              ),
            ),
          ),
        ]));
    });
    return tableRow;
  }
}
